#!/bin/sh
# \
exec wish "$0" "$@"
#
#################################################################
#   Tkmud: Xwindows mudding Application  Installation script    #
#################################################################
#    Copyright (c) 1998 Dennis Reinarz dennis@rof.net
#                       Bryan L. Nylander Bryan_Nylander@ibs.uscs.com
#
#  This program is free software; you can redistribute it and/or modify
#  it under the terms of the GNU General Public License as published by
#  the Free Software Foundation; either version 2 of the License, or
#  (at your option) any later version.
#
#  This program is distributed in the hope that it will be useful,
#  but WITHOUT ANY WARRANTY; without even the implied warranty of
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#  GNU General Public License for more details.
#
#  You should have received a copy of the GNU General Public License   
#  along with this program; if not, write to the Free Software
#  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
##########################################################################

set BACKGROUND white
set DIRECTORY ""

wm title . "\[tkmud\]: Installer"
wm iconname . "tkmud Inst" 
wm protocol . WM_DELETE_WINDOW {exit}
wm resizable . 1 1
wm geometry . 314x50
. configure -bg $BACKGROUND
option add *background                white    widgetDefault
option add *highlightcolor            red      widgetDefault
set required_files "tkmud.tcl tkmud01.gif tkmud02.gif tkmud03.gif tkmud04.gif " 

proc start_unix_install {} {
  global tcl_platform BACKGROUND message required_files DIRECTORY env
  set user_id [exec whoami]
  
  label .label -wraplength 5i -bg $BACKGROUND -justify left -text \
"Welcome to TKMUD 0.1 Installation for UNIX.
I see you are running $tcl_platform(os) as user \[$user_id\]"
  pack .label

  if {$user_id == "root" } {
    set result [tk_dialog .inform "tkmud" $message(question2) "" 0 \
    "Sure, why not, its a Tuesday" "I dont think so"]
    if {$result == 1} {
      tk_dialog .quit "tkmud" $message(quit1) "" 0 "Gotcha"
      exit
    } else {
      foreach file $required_files {
        if ![file exists $file] {
          tk_dialog .missing "tkmud" \
"Oops, for some reason you don't have $file in your present working directory.

Tkmud Installation for Unix aborted" "" 0 "Dang!"
          exit
        }
      } 
      toplevel .directory 
      .directory configure -background $BACKGROUND
      label .directory.label  -wraplength 5i -bg $BACKGROUND -justify left -text \
"Which Directory base would you like to install this under?

Ex. /usr/local"
      entry .directory.entry -relief sunken -bg #fefec4
      button .directory.ok_button -text "ok" -bg $BACKGROUND \
        -command { set DIRECTORY [.directory.entry get] ; destroy .directory}
      pack .directory.label -side top
      pack .directory.entry -side top
      pack .directory.ok_button -side bottom -ipadx 20 -pady 3 -padx 20
      focus .directory.entry
      tkwait variable DIRECTORY
      if [file exists $DIRECTORY/bin/tkmud.tcl] {
        set result [tk_dialog .file "tkmud" \
"$DIRECTORY/bin/tkmud.tcl currently exists. 
Would you like to overwrite it?" "" 0 "Sure, Nuke it" "DOH!, I'll take care of that."]
        if {$result == 1} { exit } 
      }
      if ![file isdirectory $DIRECTORY/bin] {
        catch {file mkdir $DIRECTORY/bin}
      }
      catch {file copy tkmud.tcl $DIRECTORY/bin}
      catch {file attributes -permissions 755 $DIRECTORY/bin/tkmud.tcl}
      if ![file isdirectory $DIRECTORY/lib/tkmud] { 
        catch {file mkdir $DIRECTORY/lib/tkmud}
        catch {file attributes -permissions 755 $DIRECTORY/lib/tkmud}
      }
      catch {file copy tkmud01.gif $DIRECTORY/lib/tkmud}
      catch {file copy tkmud02.gif $DIRECTORY/lib/tkmud}
      catch {file copy tkmud03.gif $DIRECTORY/lib/tkmud}
      catch {file copy tkmud04.gif $DIRECTORY/lib/tkmud}
      catch {file attributes -permissions 644 $DIRECTORY/lib/tkmud/tkmud01.gif}
      catch {file attributes -permissions 644 $DIRECTORY/lib/tkmud/tkmud02.gif}
      catch {file attributes -permissions 644 $DIRECTORY/lib/tkmud/tkmud03.gif}
      catch {file attributes -permissions 644 $DIRECTORY/lib/tkmud/tkmud04.gif}
      if ![file isdirectory /usr/etc] {
        catch {file mkdir /usr/etc}
        catch {file attribute -permissions 755 /usr/etc}
      }
      set fo [open /usr/etc/system.tkmudrc w+]
      puts $fo "TKMUD_LIB: $DIRECTORY/lib/tkmud"
      close $fo
      set fo [open $DIRECTORY/lib/tkmud/filelist.txt w+]
      puts $fo "$DIRECTORY/bin/tkmud.tcl"
      puts $fo "/usr/etc/system.tkmudrc"
      puts $fo "$DIRECTORY/lib/tkmud/tkmud01.gif"
      puts $fo "$DIRECTORY/lib/tkmud/tkmud02.gif"
      puts $fo "$DIRECTORY/lib/tkmud/tkmud03.gif"
      puts $fo "$DIRECTORY/lib/tkmud/tkmud04.gif"
      puts $fo "$DIRECTORY/lib/tkmud/filelist.txt"
      puts $fo "$DIRECTORY/lib/tkmud/"
      close $fo
    } 
    tk_dialog .done "tkmud" \
"Thats All I got to say about That.
To play type $DIRECTORY/bin/tkmud.tcl" "" 0 "Lets Play"
    exit
  } else {
    set DIRECTORY $env(HOME)
    set result [tk_dialog .start "tkmud" \
"You are not installing this under the root account. 
This will only be executable by $user_id" "" 0 "Never Mind, Ill be back" "thats good with me"]
    if {$result == 0} { exit }
    if ![file isdirectory $DIRECTORY/bin] { 
      catch {file mkdir $DIRECTORY/bin}
      catch {file attributes -permission 700 $DIRECTORY/bin}
    }
    if ![file isdirectory $DIRECTORY/lib] { 
      catch {file mkdir $DIRECTORY/lib}
      catch {file attributes -permissions 700 $DIRECTORY/lib}
    }
    if ![file isdirectory $DIRECTORY/lib/tkmud] { 
      catch {file mkdir $DIRECTORY/lib/tkmud}
      catch {file attributes -permissions 700 $DIRECTORY/lib/tkmud}
    }
    catch {file copy tkmud.tcl $DIRECTORY/bin/tkmud.tcl}
    catch {file attributes -permissions 700 $DIRECTORY/bin/tkmud.tcl}
    catch {file copy tkmud01.gif $DIRECTORY/lib/tkmud/tkmud01.gif}
    catch {file copy tkmud02.gif $DIRECTORY/lib/tkmud/tkmud02.gif}
    catch {file copy tkmud03.gif $DIRECTORY/lib/tkmud/tkmud03.gif}
    catch {file copy tkmud04.gif $DIRECTORY/lib/tkmud/tkmud04.gif}
    set fo [open $DIRECTORY/.tkmudrc w+]
    puts $fo "TKMUD_LIB: $DIRECTORY/lib/tkmud"
    close $fo
    set fo [open $DIRECTORY/lib/tkmud/filelist.txt w+]
    puts $fo "$DIRECTORY/bin/tkmud.tcl"
    puts $fo "$DIRECTORY/.tkmudrc"
    puts $fo "$DIRECTORY/lib/tkmud/tkmud01.gif"
    puts $fo "$DIRECTORY/lib/tkmud/tkmud02.gif"
    puts $fo "$DIRECTORY/lib/tkmud/tkmud03.gif"
    puts $fo "$DIRECTORY/lib/tkmud/tkmud04.gif"
    puts $fo "$DIRECTORY/lib/tkmud/filelist.txt"
    close $fo
    tk_dialog .alldone "tkmud" \
"Thats It, See, told ya it was easy.
To run this privet copy of tkmud 
type: $DIRECTORY/bin/tkmud.tcl

Happy Mudding." "" 0 "Lets Dance"
    exit
  }
}

#luny
proc start_windows_install { } {
  global tcl_platform BACKGROUND env
   label .label -wraplength 5i -bg $BACKGROUND -justify left -text \
"Welcome to TKMUD 0.1 Installation for Windows.
I See you are running $tcl_platform(os)."
   pack .label
   if ![file exists tkmud.tcl] {
     tk_dialog .error "tkmud" "tkmud.tcl not found" error \
     0 "OH NO Mr. BILL!"
     exit
   }
   if ![file exists tkmud01.gif] {
     tk_dialog .error "tkmud" "tkmud01.gif not found" error \
     0 "OH NO Mr. BILL!"
     exit    
   }
   if ![file exists tkmud02.gif] {
     tk_dialog .error "tkmud" "tkmud02.tcl not found" error \
     0 "OH NO Mr. BILL!"
     exit
   }
   if ![file exists tkmud03.gif] {
     tk_dialog .error "tkmud" "tkmud03.tcl not found" error \
     0 "OH NO Mr. BILL!"
     exit
   }
   if ![file exists tkmud04.gif] {
     tk_dialog .error "tkmud" "tkmud04.tcl not found" error \
     0 "OH NO Mr. BILL!"
     exit
   }
   label .label2 -wraplength 5i -bg $BACKGROUND -justify left -text \
"Where do you want it to Go today?"
   wm geometry . 314x98
   pack .label2 -side top
   entry .entry -relief sunken -bg #fefec4
   pack .entry -side top
   button .ok_button -text "ok" -bg $BACKGROUND \
     -command { set DIRECTORY [.entry get] 
     set temp_line [split $DIRECTORY \\ ]
     set DIRECTORY [join $temp_line /]
     catch {file mkdir $DIRECTORY}
     catch {file mkdir $DIRECTORY/lib}
     catch {file mkdir $DIRECTORY/lib/tkmud }
     catch {file copy tkmud.tcl   $DIRECTORY}
     catch {file copy tkmud01.gif $DIRECTORY/lib/tkmud}
     catch {file copy tkmud02.gif $DIRECTORY/lib/tkmud}
     catch {file copy tkmud03.gif $DIRECTORY/lib/tkmud}
     catch {file copy tkmud04.gif $DIRECTORY/lib/tkmud}
     set fo [open c:/windows/tkmud.ini w+]
     puts $fo "TKMUD_LIB: $DIRECTORY/lib/tkmud"
     close $fo
     tk_dialog .all_done "tkmud" "Happy Mudding EVERYONE" "" \
     0 "YeaY!! Finally!!" 
     exit
   }
   pack .ok_button -side bottom
}

#luny
proc start_macintosh_install { } {
   global tcl_platform BACKGROUND env
   label .label -wraplength 5i -bg $BACKGROUND -justify left -text \
"Welcome to TKMUD 0.1 Installation for Macintosh.
I See you are running $tcl_platform(os)."
   pack .label
   if ![file exists tkmud.tcl] {
     tk_dialog .error "tkmud" "tkmud.tcl not found" error \
     0 "OH NO Mr. BILL!"
     exit
   }
   if ![file exists tkmud01.gif] {
     tk_dialog .error "tkmud" "tkmud01.gif not found" error \
     0 "OH NO Mr. BILL!"
     exit    
   }
   if ![file exists tkmud02.gif] {
     tk_dialog .error "tkmud" "tkmud02.tcl not found" error \
     0 "OH NO Mr. BILL!"
     exit
   }
   if ![file exists tkmud03.gif] {
     tk_dialog .error "tkmud" "tkmud03.tcl not found" error \
     0 "OH NO Mr. BILL!"
     exit
   }
   if ![file exists tkmud04.gif] {
     tk_dialog .error "tkmud" "tkmud04.tcl not found" error \
     0 "OH NO Mr. BILL!"
     exit
   }
   label .label2 -wraplength 5i -bg $BACKGROUND -justify left -text \
"Where do you want it to install tkmud?"
   wm geometry . 314x98
   pack .label2 -side top
   entry .entry -relief sunken -bg #fefec4
   pack .entry -side top
   button .ok_button -text "ok" -bg $BACKGROUND \
     -command { set DIRECTORY [.entry get] 
     set temp_line [split $DIRECTORY \\ ]
     set DIRECTORY [join $temp_line /]
     catch {file mkdir $DIRECTORY}
     catch {file mkdir $DIRECTORY:lib}
     catch {file mkdir $DIRECTORY:lib:tkmud }
     catch {file copy tkmud.tcl   $DIRECTORY}
     catch {file copy tkmud01.gif $DIRECTORY:lib:tkmud}
     catch {file copy tkmud02.gif $DIRECTORY:lib:tkmud}
     catch {file copy tkmud03.gif $DIRECTORY:lib:tkmud}
     catch {file copy tkmud04.gif $DIRECTORY:lib:tkmud}
     set fo [open $env(PREF_FOLDER) w+]
     puts $fo "TKMUD_LIB: $DIRECTORY:lib:tkmud"
     close $fo
     tk_dialog .all_done "tkmud" "Happy Mudding EVERYONE" "" \
     0 "YeaY!! Finally!!" 
     exit
   }
   pack .ok_button -side bottom
}




# Determin which installer to use dependent on which os is being used
proc main { } {
  global tcl_platform
  switch $tcl_platform(platform) {
    unix {
      start_unix_install
    }
    windows {
      start_windows_install
    }
    macintosh {
      start_macintosh_install
    }
  }
}

# Those Dirty little message Things... Keep them down here so they dont
# become such an eyesore in the code
# msgs

set message(error1) "Well, you have to enter SOMETHING at least..

I know,, Try this, its easy,

/tkmud

Kewl?"

set message(error2) "You must provide the full path of
where you are going to install TKMUD.

Example: /games/tkmud"

set message(error3) "You have TKMUD already installed in this location"

set message(question1) "I see this is a new directory. its Ok to create it right?"

set message(question2) "As root do you want to install this system wide?"

set message(quit1) "You will have to log out, and run this again under a different user"

set message(unix1) "Welcome to TkMud 0.1 Installation for Unix.
I see you are running $tcl_platform(os) as \[user_id\]."


# LET THE GAMES BEGIN!!!

main
